package com.loafle.overflow.module.sensor.dao;

import com.loafle.overflow.AppConfig;
import com.loafle.overflow.JdbcConfiguration;
import com.loafle.overflow.meta.model.MetaCrawler;
import com.loafle.overflow.meta.model.MetaCrawlerInputItem;
import com.loafle.overflow.meta.model.MetaSensorStatus;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.target.model.Target;
import org.junit.*;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.Date;
import java.util.List;

@Ignore
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class})
public class SensorDAOTest {

    @Autowired
    private SensorDAO sensorDAO;


    @Before
    public void setUp() throws Exception {
        create();
    }

    @After
    public void tearDown() throws Exception {
    }


    @Test
    public void create() {
        Sensor sensor = new Sensor();
        sensor.setDescription("My sensor");
        sensor.setCreateDate(new Date());

        MetaSensorStatus status = new MetaSensorStatus();
        status.setId((short)1);
        sensor.setStatus(status);

        Target target = new Target();
        target.setId(1);
        sensor.setTarget(target);

        MetaCrawler crawler = new MetaCrawler();
        crawler.setId((short)1);

        MetaCrawlerInputItem inputItem = new MetaCrawlerInputItem();
        inputItem.setId(1);

        sensor.setCrawler(crawler);
        sensorDAO.save(sensor);
    }

    @Test
    public void list() {
        Target t = new Target();
        t.setId(1);
        List<Sensor> sensors = this.sensorDAO.findAllByTarget(t);
        Assert.assertEquals(2, sensors.size());
    }

}